#!/usr/bin/env python

# This is a very simple commandline-tool to add new Screenlets to the daemon
#
# (c) 2007 RYX (aka Rico Pfaus) <ryx@ryxperience.com>
#

import dbus
import sys

NOTE = 'add-screenlet-utility | (c) RYX (Rico Pfaus) 2007 | released under GPL'
USAGE = 'usage: ' + sys.argv[0] + ' [options] <classname> <classname> ...'

bus = dbus.SessionBus()
proxy_obj = bus.get_object('org.freedesktop.Screenlets', 
'/org/freedesktop/Screenlets')
backend = dbus.Interface(proxy_obj, 'org.freedesktop.Screenlets')


print NOTE
	
# parse arguments
argc = len(sys.argv)
names = []
if argc > 1:
	for i in range(1, argc):
		arg = sys.argv[i]
		if arg.startswith('--'):
			print "Option "+arg+" not implemented"
		else:
			names.append(arg + 'Screenlet')

# no classes defined? print usage
if len(names)==0:
	print USAGE
else:
	# create new Screenlet(s) inside the backend
	try:
		for cname in names:
			#print "Adding: "+cname+" to "+str(backend)
			if backend.add(cname, False):
				print cname + " successfully created."
			else:
				print "Class " + cname + " not found."
	except:
		print "Error: Screenlets-Backend (screenletsd) not found."

